/**
  * Fill - A lightweight JavaScript layout library.
  * ver. 0.1.4 (2015-01-25)
  * git: https://github.com/boundingdog/fill
  *
  * (c) 2014-2015 boundingdog, LLC
  * Licensed MIT 2015 boundingdog, LLC (http://www.boundingdog.com)
  **/

var fill=fill||{};fill.classes=fill.classes||{},function($){var DATA_REGEX=/\b([\w|-]+)\s*:\s*([\w|"|'|\*]+)\s*;?/g,region=function(el,options){this.el=el,this._init(options)};region.prototype._init=function(options){var str,contentClass,defaults;if(this._origStyle=this.el.attr("style"),this.el.css({position:"absolute"}),defaults={row:-1,col:-1,rowSpan:1,colSpan:1,contentClass:"",top:!1,right:!1,bottom:!1,left:!1},this._properties=$.extend({},defaults,options),str=this.el.data("fill"))for(;null!==(match=DATA_REGEX.exec(str));)3===match.length&&(this._properties[match[1]]=parseInt(match[2],10));contentClass="",this._properties.contentClass&&""!==this._properties.contentClass.trim()&&(contentClass=this._properties.contentClass),this.el.wrapInner("<div class='fill-region-wrapper "+contentClass+"'></div>").children().first().css({"-webkit-box-sizing":"border-box","-moz-box-sizing":"border-box","box-sizing":"border-box"})},region.prototype.get=function(name){return"undefined"!=typeof this._properties[name]?this._properties[name]:null},region.prototype.setEdges=function(top,right,bottom,left){var removeClass;this._properties.top=top,this._properties.right=right,this._properties.bottom=bottom,this._properties.left=left,this.el.addClass("fill"+(top?" fill-top":"")+(right?" fill-right":"")+(bottom?" fill-bottom":"")+(left?" fill-left":"")),removeClass="",top||(removeClass+="fill-top "),right||(removeClass+="fill-right "),bottom||(removeClass+="fill-bottom "),left||(removeClass+="fill-left "),this.el.removeClass(removeClass)},region.prototype.fireResizeEvent=function(){var width,height;width=this.el.width(),height=this.el.height(),data={previous:{width:this._properties.width,height:this._properties.height},current:{}},this._properties.width=width,this._properties.height=height,void 0===data.previous.width||data.previous.width===width&&data.previous.height===height||(data.current.width=width,data.current.height=height,this.el.trigger("fillresize",data))},region.prototype.destroy=function(){this.el.html($("> .fill-region-wrapper",this.el).html()),this._origStyle?this.el.attr("style",this._origStyle):this.el.removeAttr("style"),this.el.removeClass("fill fill-top fill-right fill-bottom fill-left")},fill.classes.Region=region}(jQuery);var fill=fill||{};fill.classes=fill.classes||{},function($){var listener=function(){this._callbacks={}};listener.prototype.addHandler=function(callback){var id,self=this;return id=(new Date).getTime(),this._callbacks[id]=callback,1===Object.keys(this._callbacks).length&&$(window).on("resize.fill",function(){self._fireResizeEvent()}),id},listener.prototype.removeHandler=function(id){delete this._callbacks[id],0===Object.keys(this._callbacks).length&&$(window).off("resize.fill")},listener.prototype._fireResizeEvent=function(){for(var id in this._callbacks)this._callbacks[id]()},fill.classes.WindowResizeListener=new listener}(jQuery);var fill=fill||{};fill.classes=fill.classes||{},function($){var calculator=function(container){this._container=container,this._rows={key:"row",sizes:{}},this._cols={key:"col",sizes:{}}};calculator.prototype.addCell=function(row,col){"undefined"==typeof this._rows.sizes[row]&&(this._rows.sizes[row]={type:null}),"undefined"==typeof this._cols[col]&&(this._cols.sizes[col]={type:null})},calculator.prototype.getRowHeight=function(row){return this._rows.sizes[row].size},calculator.prototype.getColWidth=function(col){return this._cols.sizes[col].size},calculator.prototype.calculate=function(width,height){width>0&&this._calculate(this._cols,width),height>0&&this._calculate(this._rows,height)},calculator.prototype._calculate=function(map,size){var itemCnt,remaining,userCells;itemCnt=userCells=Object.keys(map.sizes).length,remaining=size;for(var i=0;itemCnt>i;i++)"computed"!==map.type&&(map.sizes[i].size=this._detectUserSize(map.key,i),map.sizes[i].type=0<map.sizes[i].size?"user":"computed"),0<map.sizes[i].size&&(remaining-=map.sizes[i].size,userCells--);for(var i=0;itemCnt>i;i++)"computed"===map.sizes[i].type&&(map.sizes[i].size=remaining/userCells)},calculator.prototype._detectUserSize=function(key,index){var el,size=0;return el=$("<div class='fill-"+key+"-"+index+"' style='float:left;visibility:hidden'></div>").appendTo(this._container),"row"===key?size=el.height():"col"===key&&(size=el.width()),el.remove(),size},fill.classes.CellSizeCalculator=calculator}(jQuery);var fill=fill||{};fill.classes=fill.classes||{},function($){var layoutManager=function(el,options){var defaults={padding:0};this._config=$.extend({},defaults,options),this._el=el,this._init()};layoutManager.prototype._init=function(){this._config.pixelPadding=this._getPaddingInPixels(this._config.padding),this._origStyle=this._el.attr("style"),this._el.css({position:"relative"}),this._cellCalculator=new fill.classes.CellSizeCalculator(this._el),this._buildLayout(),this._cellCalculator.calculate(this._width-this._config.pixelPadding,this._height-this._config.pixelPadding),this._renderLayout(),this._el.trigger("fillcreate",{})},layoutManager.prototype._buildLayout=function(){var regions,region,row,col,grid,rows,colCnt;this._width=this._el.width(),this._height=this._el.height(),this._dimensions={rows:{},cols:{}},grid={},colCnt=0,regions=$("> [data-fill]",this._el);for(var i=0;i<regions.length;i++)region=new fill.classes.Region($(regions[i]),{contentClass:this._config.contentClass}),row=region.get("row"),col=region.get("col"),null===row||null===col||0>row||0>col?console.warn("Fill region does not have a row and col defined. Region will be skipped"):(grid[row]||(grid[row]={}),grid[row][col]?console.warn("Duplicate region defined for fill region ("+row+","+col+"). Region will be skipped."):(this._cellCalculator.addCell(row,col),grid[row][col]=region,colCnt<Object.keys(grid[row]).length&&colCnt++));rows=Object.keys(grid),this._grid=new Array(rows);for(var row in grid){this._grid[row]=new Array(colCnt);for(var col in grid[row])region=grid[row][col],region.setEdges(0==row,col-1+region.get("colSpan")==colCnt-1,row-1+region.get("rowSpan")==rows.length-1,0==col),this._grid[row][col]=region}},layoutManager.prototype._renderLayout=function(){var region,x,y,regionWid,regionHt,args,pixelPadding,halfPadding,padding;if(!this._grid||0===this._grid.length)return 0;pixelPadding=this._config.pixelPadding,halfPadding=pixelPadding/2,y=halfPadding;for(var row=0;row<this._grid.length;row++){x=halfPadding;for(var col=0;col<this._grid[row].length;col++)if(region=this._grid[row][col],"undefined"!=typeof region&&null!==region){regionWid=this._cellCalculator.getColWidth(col);for(var tmp=col+1;tmp<col+region.get("colSpan");tmp++)regionWid+=this._cellCalculator.getColWidth(tmp);regionHt=this._cellCalculator.getRowHeight(row);for(var tmp=row+1;tmp<row+region.get("rowSpan");tmp++)regionHt+=this._cellCalculator.getRowHeight(tmp);args={top:y+"px",left:x+"px",width:regionWid-pixelPadding+"px",height:regionHt-pixelPadding+"px"},region.get("right")&&(delete args.width,args.right=this._width-(x+regionWid)+"px"),region.get("bottom")&&(delete args.height,args.bottom=this._height-(y+regionHt)+"px"),0!==pixelPadding&&(padding=halfPadding+"px "+halfPadding+"px ",padding+=halfPadding+"px "+halfPadding+"px",args.padding=padding),region.el.css(args),region.fireResizeEvent(),x+=this._cellCalculator.getColWidth(col)}else x+=this._cellCalculator.getColWidth(col);y+=this._cellCalculator.getRowHeight(row)}},layoutManager.prototype._getPaddingInPixels=function(padding){var tempEl,pixel=padding;return"string"==typeof padding?padding.indexOf("px")===padding.length-2?pixel=parseInt(padding.substr(0,padding.length-2),10):(tempEl=$("<div style='position:absolute;visible:visible;width:"+padding+"'></div>").appendTo(this._el),pixel=tempEl.width(),tempEl.remove()):(tempEl=$("<div style='position:absolute;visible:visible;' class='fill-padding'></div>").appendTo(this._el),tempEl.outerWidth()===tempEl.outerHeight()?pixel=Math.floor(tempEl.outerWidth()/2):(console.warn("Fill layout manager does not support different vertical and horizontal paddings."),pixel=0),tempEl.remove()),pixel},layoutManager.prototype.refresh=function(){var newWid,newHt;newWid=this._el.width(),newHt=this._el.height(),(newWid!==this._width||newHt!==this._height)&&(this._cellCalculator.calculate(newWid!==this._width?newWid-this._config.pixelPadding:-1,newHt!==this._height?newHt-this._config.pixelPadding:-1),this._width=newWid,this._height=newHt),this._renderLayout()},layoutManager.prototype.destroy=function(){var region;if(0<this._grid.length)for(var i=0;i<this._grid.length;i++)for(var j=0;j<this._grid[i].length;j++)region=this._grid[i][j],"undefined"!=typeof region&&null!==region&&region.destroy();this._origStyle?this._el.attr("style",this._origStyle):this._el.removeAttr("style"),this._el.trigger("filldestroy",{})},fill.classes.LayoutManager=layoutManager}(jQuery);var fill=fill||{};fill.classes=fill.classes||{},function($){var plugin=function(el,options){var defaults={autoRefresh:!0};this._init(el,$.extend({},defaults,options))};plugin.prototype._init=function(el,config){var self=this;this._el=el,this._config=config,this._registerEventListeners(),this._layoutManager=new fill.classes.LayoutManager(el,config),this._config.autoRefresh&&(this._resizeHandlerId=fill.classes.WindowResizeListener.addHandler(function(){self._refresh()}))},plugin.prototype._registerEventListeners=function(){this._config.create&&this._el.on("fillcreate.fill-internal",this._config.create),this._config.resize&&this._el.on("fillresize.fill-internal",this._config.resize),this._config.destroy&&this._el.on("filldestroy.fill-internal",this._config.destroy)},plugin.prototype._refresh=function(){this._layoutManager.refresh()},plugin.prototype.refresh=function(){this._refresh()},plugin.prototype.destroy=function(){this._resizeHandlerId&&fill.classes.WindowResizeListener.removeHandler(this._resizeHandlerId),this._layoutManager.destroy(),delete this._layoutManager,this._el.off("fillcreate.fill-internal"),this._el.off("filldestroy.fill-internal"),this._el.off("fillresize.fill-internal")},fill.classes.FillPlugin=plugin}(jQuery);var fill=fill||{};!function($){fill.version="0.1.0";var plugin=function(){var el,plugin,args,action,options;return args=$.makeArray(arguments),"string"==typeof args[0]&&(action=args[0],args=args.splice(0)),options=args[0],$.each(this,function(){el=$(this),plugin=el.data("fill-pi"),plugin||action?plugin&&action&&(plugin[action](options),"destroy"===action&&el.removeData("fill-pi")):(plugin=new fill.classes.FillPlugin(el,options),el.data("fill-pi",plugin))}),this};$.fn.fill?console.warn("jQuery.fn.fill is already defined. Fill Layout Manager cannot be loaded."):$.fn.fill=plugin}(jQuery);
//# sourceMappingURL=fill.min.js.map